--[[
		SuperGuildInvite by Janniie - Stormreaver EU
		
		~~Special thanks to~~   
			Minayuki - Argent Dawn EU

]]
local ID = "SG_INV"
local ID2 = "SGI_REQ"
local ID3 = "SGI_BLACK"
local version = "3.3"
local version_min = ""
local Frames = {}
local inBattleground = false
local inDungeon = false
local DungeonFinnished = false
local WhoTime = GetTime() + 10
local ScanZone,AllZones = 1,{}
local TimerTime = 0
local TimeLeft = 0
local cooldown = false
local Logo = "|cffffff00<|r|cff16ABB5SGI|r|cffffff00>|r "

-- A fix for 4.3 where GuildInvite() will have a 1sec cooldown --
local InviteQueue = {}
local InviteDelay = 0
local WhoDelay = 7
local LastInvite = 0
local WaitForWho = false

Funcs = {}

-- NOTES TO SELF--
--
-- TO DO 3.0:
-- >> Search all server								NOT DOABLE
-- >> Custom Whisper -- 							DONE
-- >> Finnish the new UI --							MOSTLY DONE
-- >> Invite Whisper Requests  --					DONE, Untested
-- >> Cross-Realm Areas and BG's, Dungeons DISABLE	DONE
-- >> Manual Searches -- 							DONE
-- >> Black list 									DONE
-- >> Off By Default --								DONE

-- TO DO FOR 3.1:
-- >> Systematic Scans								DONE
-- >> Fix ESC button								DONE
-- >> Synchronize within the guild					DONE

local function Add_To_Blacklist(name,mode)
	BlackList[name] = mode
	SendAddonMessage(ID3,"","GUILD")
	print(Logo.."|cffff0000"..name.."|r|cff88ffff has been added to the |r|cff111111BlackList|r")
end	


local function QueueInvite(name)
	tinsert(InviteQueue,name)
end

local function InviteQueueHandle()
	if GetTime() - LastInvite > InviteDelay and WaitForWho then
		for k,_ in pairs(InviteQueue) do
			GuildInvite(InviteQueue[k])
			if SuperGuildInviteOptions["OptBtn2"] then
				SendChatMessage(SuperGuildInviteOptions.Whisper,"WHISPER",nil,InviteQueue[k])
			end
			ChatFrame1:AddMessage(Logo.."SuperGuildInvite tried to invite "..InviteQueue[k].." to your Guild.",0.28,0.46,1,1)
			tremove(InviteQueue,k)
			break
		end
		LastInvite = GetTime()
		if #InviteQueue == 0 then
			WaitForWho = false
		end
	end
end
local InviteQueueFrame = CreateFrame("Frame")
InviteQueueFrame:SetScript("OnUpdate",InviteQueueHandle)



local function SuperScan()
	if SuperGuildInviteOptions["OptBtn1"] and SuperGuildInviteOptions["OptBtn9"] and GetTime() - WhoTime > WhoDelay then
		local i = 0
		for k,_ in pairs(AllZones) do
			i = i + 1
			local zone = AllZones[k]
			if ScanZone == i then
				ScanZone = ScanZone + 1
				SetWhoToUI(1)
				SendWho(zone)
				SuperGuildInviteGeneral.DoInvites = true
				TimeLeft = (#AllZones-ScanZone + 2) * WhoDelay
				cooldown = false
				break
			elseif i == #AllZones then
				ScanZone = 1
				print(Logo.."|cff16ABB5Scan Completed.|r")
				WhoTime = GetTime() + 5
				TimeLeft = 10
				cooldown = true
				return
			end
		end
		WhoTime = GetTime()
	end
end
local ff = CreateFrame("Frame")
ff:SetScript("OnUpdate",SuperScan)

--Registered Events--

local function ZoneChanged()
	local WhoReqZone = GetRealZoneText()
	if IsInGuild() and CanGuildInvite() and SuperGuildInviteOptions["OptBtn1"] then
		SetWhoToUI(1)
		SendWho("z-"..WhoReqZone.."")
		SuperGuildInviteGeneral.DoInvites = true
	elseif not IsInGuild() then
		SuperGuildInviteOptions["OptBtn1"] = false
		print(Logo.."|cff88FFFFYour are currently not in a guild, SGI will automatically turn off.|r")
		print(Logo.."|cffFF0000SGI is now turned OFF|r")
	elseif not IsInGuild() and not CanGuildInvite() then
		SuperGuildInviteOptions["OptBtn1"] = false
		print(Logo.."|cff88FFFFYour are currently in a guild, but you cannot invite players, so SGI will turn off.|r")
		print(Logo.."|cffFF0000SGI is now turned OFF|r")
	end
end

local function WhoList()
	if SuperGuildInviteOptions["OptBtn1"] and SuperGuildInviteGeneral.DoInvites then
		SuperGuildInviteGeneral.DoInvites = false
		for i = 1,GetNumWhoResults() do
			local name, guild = GetWhoInfo(i)
			if guild == "" then 
				ChatFrame1:AddMessage(Logo..name.." is not a member of any guild.",1,0.2,0.2,1)
				InviteTime = tonumber(date("%j"))
				if SuperGuildInviteOptions["OptBtn4"] == 1 then
					extra = 0
				elseif SuperGuildInviteOptions["OptBtn4"] == 2 then
					extra = 1
				else
					extra = 2
				end
				if (not SuperGuildInviteGeneral["DATES"][name] or InviteTime > (extra + SuperGuildInviteGeneral["DATES"][name])) then
					if not BlackList[name] then
						SuperGuildInviteGeneral["DATES"][name] = InviteTime
						SuperGuildInviteGeneral["TRIES"]["tries "..name] = (SuperGuildInviteGeneral["TRIES"]["tries "..name] or 0) + 1
						if SuperGuildInviteGeneral["TRIES"]["tries "..name] > (SuperGuildInviteOptions.tries or 100) then
							Add_To_Blacklist(name,"AUTOMATIC")
						else
							QueueInvite(name)
						end
					else
						print(Logo.."|cffff0000"..name.."|r|cff88ffffis|r|cff11111BlackListed|r")
					end
				else
					if BlackList[name] then 
						print(Logo.."|cffff0000"..name.."|r|cff88ffff is|r|cff111111 BlackListed|r")
					else
						ChatFrame1:AddMessage(Logo..name.." has declined an invitation in less than the specified time, will not invite now.",0.93,0.705,0.13,1)
					end
				end
			end
		end
		if SuperGuildInviteOptions["OptBtn3"] then
			FriendsFrameCloseButton:Click()
		end
		if SuperGuildInviteOptions["OptBtn5"] then
			Frames["OptBtn5"]:SetTextColor(1,0,0)
		end
		WaitForWho = true
	end
end

local function LoginPlayer()
	if type(SuperGuildInviteGeneral) ~= "table" or tonumber(date("%j")) < (SuperGuildInviteGeneral[UnitName("Player")] or 0) then --New user or new year
		SuperGuildInviteGeneral = {}
		SuperGuildInviteGeneral["DATES"] = {}
		SuperGuildInviteGeneral["TRIES"] = {}
		SuperGuildInviteGeneral[UnitName("Player")] = tonumber(date("%j"))
	end
	if type(SuperGuildInviteGeneral["DATES"]) ~= "table" then
		SuperGuildInviteGeneral["DATES"] = {}
	end
	if type(SuperGuildInviteGeneral["TRIES"]) ~= "table" then
		SuperGuildInviteGeneral["TRIES"] = {}
	end
	if type(SuperGuildInviteOptions) ~= "table" then
		SuperGuildInviteOptions = {}
		SuperGuildInviteOptions["OptBtn1"] = false
		
		SuperGuildInviteOptions.Whisper = "Would you like to join my guild? The please press Accept!"
	end
	if type(BlackList) ~= "table" then
		BlackList = {}
	end
	print(Logo.."|cff88ffffType /sgi, or /sgi help to show help")
	if SuperGuildInviteOptions["OptBtn1"] then
		ChatFrame1:AddMessage(Logo.."SuperGuildInvite is ON",0,1,0,1)
	else
		ChatFrame1:AddMessage(Logo.."SuperGuildInvite is OFF",1,0,0,1)
	end
	SendAddonMessage(ID,version,"GUILD")
	SendAddonMessage(ID2,"","GUILD")
	SuperGuildInviteOptions.OptionsFrame = nil
	SuperGuildInviteOptions.Search = nil
	SuperGuildInviteOptions["OptBtn5"] = nil
	SuperGuildInviteOptions["OptBtn9"] = nil
	cooldown = true
	
	if select(4,GetBuildInfo()) > 40200 then 
		InviteDelay = 1.1
		WhoDelay = 9 
	else 
		InviteDelay = 0.3 
		WhoDelay = 7 
	end
	
	
	local Levels,i = {"-5"},5
	
	while i<80 do
		tinsert(Levels,i.."- -"..(i+5))
		i = i + 5
	end
	tinsert(Levels,"80- -82")
	tinsert(Levels,"83- -84")
	
	local Classes = {
		"Death Knight",
		"Priest",
		"Druid",
		"Mage",
		"Warrior",
		"Warlock",
		"Paladin",
		"Rogue",
		"Shaman",
		"Hunter",
	}
	for k,_ in pairs(Classes) do
		tinsert(Levels,"85 c-"..Classes[k])
	end
	AllZones = Levels

	for k,_ in pairs(SuperGuildInviteGeneral["DATES"]) do
		if SuperGuildInviteGeneral["DATES"][k] + 4 < tonumber(date("%j")) then
			SuperGuildInviteGeneral["DATES"][k] = nil
		end
	end
	
end

local function AddOnMsg(prefix,msg,sender)
	if prefix == ID then
		if tonumber(version)<(tonumber(msg) or 0) then
			ChatFrame1:AddMessage(Logo.."A new version ("..msg..") of SuperGuildInvite is available",0.5,1,1,1)
		end
	elseif prefix == ID2 and sender ~= UnitName("player") then
		for k,_ in pairs(BlackList) do
			SendAddonMessage(ID3,"NAME:"..k.."MODE:"..BlackList[k],"GUILD")
		end
	elseif prefix == ID3 and sender ~= UnitName("player") then
		local name = strsub(msg,6,strfind(msg,"MODE:")-1)
		local mode = strsub(msg,strfind(msg,"MODE:")+5)
		Add_To_Blacklist(name,mode)
	end
end


local function OnWhisper(msg,sender)
	if IsInGuild() then
		local gName = GetGuildInfo(UnitName("Player"))
		msg = strlower(msg)
		if (sender ~= UnitName("Player")) and CanGuildInvite() and SuperGuildInviteOptions["OptBtn8"] then
			if (strfind(msg,"join") or strfind(msg,"inv")) and (strfind(msg,"guild") or strfind(msg,gName)) then
				SetWhoToUI(1)
				SendWho(sender)
				SuperGuildInviteGeneral.DoInvites = true
			end
		end
	end
end


local function OnBattleground()
	if SuperGuildInviteOptions["OptBtn1"] then
		inBattleground = true
		SuperGuildInviteOptions["OptBtn1"] = false
		print(Logo.."|cff88ffffYou have entered a Cross-Realm area. SGI will turn off untill you're done.|r")
		print(Logo.."|cffff0000SuperGuildInvite is OFF|r")
	end
end

local function OnBGExit()
	if inBattleground then
		inBattleground = false
		SuperGuildInviteOptions["OptBtn1"] = true
		print(Logo.."|cff88ffffCross-Realm area Exited, SGI will be turned on again.|r")
		print(Logo.."|cff00ff00SuperGuildInvite is ON|r")
	elseif inDungeon and DungeonFinnished then
		SuperGuildInviteOptions["OptBtn1"] = true
		print(Logo.."|cff88ffffCross-Realm area Exited, SGI will be turned on again.|r")
		print(Logo.."|cff00ff00SuperGuildInvite is ON|r")
		inDungeon = false
	end
end
	

local function OnLFDgroup()
	if SuperGuildInviteOptions["OptBtn1"] then
		inDungeon = true
		SuperGuildInviteOptions["OptBtn1"] = false
		print(Logo.."|cff88ffffYou have entered a Cross-Realm area. SGI will turn off untill you're done.|r")
		print(Logo.."|cffff0000SuperGuildInvite is OFF|r")
	end
end

local function LFD_finnished()
	if inDungeon then
		inDungeon = false
		SuperGuildInviteOptions["OptBtn1"] = true
		print(Logo.."|cff88ffffCross-Realm area Exited, SGI will be turned on again.|r")
		print(Logo.."|cff00ff00SuperGuildInvite is ON|r")
	end
end

local function OnSystemMsg(msg) 
	if msg == "You leave the group." or msg == "You have been removed from the group." and inDungeon then
		DungeonFinnished = true
	end
end

local function DungeonReward()
	if inDungeon then
		DungeonFinnished = true
	end
end
	
local function OnRegisteredEvent(self,event,...)
	if event == "ZONE_CHANGED_NEW_AREA" then
		ZoneChanged()
	elseif event == "WHO_LIST_UPDATE" then
		WhoList()
	elseif event == "PLAYER_LOGIN" then
		LoginPlayer()
	elseif event == "CHAT_MSG_ADDON" then
		local prefix,msg,channel,sender = select(1,...)
		AddOnMsg(prefix,msg,sender)
	elseif event == "CHAT_MSG_WHISPER" then
		local msg,sndr = select(1,...)
		OnWhisper(msg,sndr)
	elseif event == "CHAT_MSG_SYSTEM" then
		local msg = select(1,...)
		OnSystemMsg(msg)
	elseif event == "PLAYER_ENTERING_BATTLEGROUND" then
		OnBattleground()
	elseif event == "PLAYER_ENTERING_WORLD" then
		OnBGExit()
	elseif event == "LFG_PROPOSAL_SUCCEEDED" then
		OnLFDgroup()
	elseif event == "LFG_COMPLETION_REWARD" then
		DungeonReward()
	end
end






-- Frames --

local function SetSavedFramePos(Frame)
	if not Frame then print(Logo.."Error: No frame") end
	
	local name = Frame:GetName()

	SuperGuildInviteOptions[name.."Xpos"] = SuperGuildInviteOptions[name.."Xpos"] or 0
	SuperGuildInviteOptions[name.."Ypos"] = SuperGuildInviteOptions[name.."Ypos"] or 0
	SuperGuildInviteOptions[name.."P1"] = SuperGuildInviteOptions[name.."P1"] or "CENTER"
	SuperGuildInviteOptions[name.."P2"] = SuperGuildInviteOptions[name.."P2"] or "CENTER"

	
	Frame:SetPoint(SuperGuildInviteOptions[name.."P1"],UIParent,SuperGuildInviteOptions[name.."P2"],SuperGuildInviteOptions[name.."Xpos"],SuperGuildInviteOptions[name.."Ypos"])
end

local function SaveCurFramePos(Frame)
	if not Frame then print(Logo.."Error: No frame") end
	
	local name = Frame:GetName()

	local point, relativeTo, relativePoint, xOfs, yOfs = Frame:GetPoint()

	SuperGuildInviteOptions[name.."Xpos"] = xOfs
	SuperGuildInviteOptions[name.."Ypos"] = yOfs
	SuperGuildInviteOptions[name.."P1"] = point
	SuperGuildInviteOptions[name.."P2"] = relativePoint
end

local function CreateButton(name,parent)
	local frame = CreateFrame("Button",name,parent,"UIPanelButtonTemplate")
	frame:SetWidth(60)
	frame:SetHeight(20)
	frame:SetPoint("CENTER")
	
	local font = frame:CreateFontString(nil,"OVERLAY","GameFontNormal")
	font:SetText("")
	font:SetPoint("CENTER")
	return frame
end

local function Modify_Button(Button,text,Height,Width,Color,Anchor,FUNCTION,FUNCTION2)
	if not Button then print(Logo.."error in (function) Modify_Button") return end
	if text then
		local font = Button:GetFontString()
		font:SetText(text)
	end
	if Height or Width then
		if Height then
			Button:SetHeight(Height)
		end
		if Width then
			Button:SetWidth(Width)
		end
	end
	if type(Color) == "table" then
		local font = Button:GetFontString()
		font:SetTextColor(Color.Red,Color.Green,Color.Blue)
	end
	if type(Anchor) == "table" then
		Button:SetPoint(Anchor.Point,Anchor.RelativeFrame,Anchor.RelativePoint,Anchor.xOfs,Anchor.yOfs)
	end
	if FUNCTION then
		Button:SetScript("OnClick",FUNCTION)
	end
	if FUNCTION2 then
		Button:SetScript("OnEnter",FUNCTION2)
		Button:SetScript("OnLeave",FUNCTION2)
	end
end



local function Checkbox_OnClick(self)
	local Enabled = self:GetChecked()
	if Enabled == 1 then
		Settings["CheckBox: "..self:GetName()] = true
	else
		Settings["CheckBox: "..self:GetName()] = false
	end
	BlizzardOptionsPanel_CheckButton_OnClick(self)
end

local function Checkbox_OnEnter(self)
	local child = self:GetChildren()
	child:Show()
end

local function Checkbox_OnLeave(self)
	local child = self:GetChildren()
	child:Hide()
end

local function CreateCheckBox(name,parent,index)
	local check = CreateFrame("CheckButton",name,parent,"OptionsBaseCheckButtonTemplate")
	check:SetPoint("LEFT");
	check:SetScript("OnClick", Checkbox_OnClick);
	check:SetScript("OnEnter",Checkbox_OnEnter) 
	check:SetScript("OnLeave", Checkbox_OnLeave);
	if SuperGuildInviteOptions["CheckBox: "..name] then
		check:SetChecked(true)
	end
	local font = check:CreateFontString("CheckFont"..index,"OVERLAY","GameFontNormal")
	font:SetText("checkbox text")
	font:SetPoint("LEFT",check,"RIGHT",5,1)
	return check,font
end


--****************************************--
--** Function to configure the Checkbox **--
--****************************************--
local function Modify_CheckButton(button,font,text,color,anchor)
	if not button then return end
	if text then
		if font then
			font:SetText(text)
		end
	end
	if type(color) == "table" then
		local font = button:GetFontString()
		font:SetTextColor(color.Red,color.Green,color.Blue)
	end
	if type(anchor) == "table" then
		button:SetPoint(anchor.Point,anchor.RelativeFrame,anchor.RelativePoint,anchor.xOfs,anchor.yOfs)
	end
end


local function CreateTimerWorld()
	local backdrop = 
	{
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Background", 
		edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Border", 
		tile = true,
		tileSize = 16,
		edgeSize = 16,
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
	}
	
	local Timer = CreateFrame("Button","Timer",OptionsFrame)
	Timer:SetHeight(40)
	Timer:SetWidth(240)
	Timer:SetPoint("TOP",UIParent,"TOP",0,-30)
	Timer:SetMovable()
	Timer:RegisterForDrag("LeftButton","RightButton")
	Timer:SetScript("OnMouseDown",function(self)
		self:StartMoving()
	end)
	Timer:SetScript("OnMouseUp",function(self)
		self:StopMovingOrSizing()
	end)
	Timer:SetBackdrop(backdrop)
	
	local TimerFont = Timer:CreateFontString(nil,"OVERLAY","GameFontNormal")
	TimerFont:SetText("hh:mm:ss")
	TimerFont:SetPoint("CENTER")
	--Timer:SetScript("OnUpdate",UpdateTime)
	Frames["TimerFont"] = TimerFont
	Frames["Timer"] = Timer
end

local function UpdateTime()
	if GetTime() - TimerTime >= 1 then
		local Time
		if TimeLeft <= 0 then
			Time = "New scan starting in: 00:00:00"
		else
			local sec = TimeLeft
			local hour = floor(sec/3600)
			local mins = floor((sec-3600*hour)/60)
			local secs = sec-3600*hour-60*mins
			if hour < 10 then hour = "0"..hour end
			if mins < 10 then mins = "0"..mins end
			if secs < 10 then secs = "0"..secs end
			local text
			if cooldown then
				text = "New scan starting in: "
				if TimeLeft <= 1 then
					cooldown = false
				end
			else
				text = "Estimated time remaining: "
			end
			Time = text..hour..":"..mins..":"..secs
		end
		Frames["TimerFont"]:SetText(Time)
		TimeLeft = TimeLeft - 1
		TimerTime = GetTime()
	end
end


local function OnOptionClick(self)
	local name = self:GetName()
	
	if SuperGuildInviteOptions[name] then
		SuperGuildInviteOptions[name] = false
		Frames[name]:SetTextColor(1,0,0)
		if name == "OptBtn5" then
			SuperGuildInviteGeneral.DoInvites = false
		elseif name == "OptBtn1" then
			print(Logo.."|cffff0000SuperGuildInvite is OFF|r")
		elseif name == "OptBtn2" then
			print(Logo.."|cffff0000Whisper before invite turned OFF|r")
		elseif name == "OptBtn3" then
			print(Logo.."|cffff0000Auto-Close after who search OFF|r")
		elseif name == "OptBtn8" then
			print(Logo.."|cffff0000Invite whisper requests turned OFF|r")
		elseif name == "OptBtn9" then
			print(Logo.."|cffff0000SuperScan turned OFF|r")
			if Frames["Timer"] then Frames["Timer"]:Hide() end
		end
	else
		SuperGuildInviteOptions[name] = true
		Frames[name]:SetTextColor(0,1,0)
		if name == "OptBtn5" then
			SuperGuildInviteGeneral.DoInvites = true
		elseif name == "OptBtn1" then
			print(Logo.."|cff00ff00SuperGuildInvite is ON|r")
		elseif name == "OptBtn2" then
			print(Logo.."|cff00ff00Whisper before invite turned ON|r")
		elseif name == "OptBtn3" then
			print(Logo.."|cff00ff00Auto-Close after who search ON|r")
		elseif name == "OptBtn8" then
			print(Logo.."|cff00ff00Invite whisper requests turned ON|r")
		elseif name == "OptBtn9" then
			print(Logo.."|cff00ff00SuperScan turned ON|r")
			if not Frames["Timer"] then
				CreateTimerWorld()
				Frames["Timer"]:Show()
			else
				Frames["Timer"]:Show()
			end
			Frames["Timer"]:SetScript("OnUpdate",UpdateTime)
			if GetTime()-WhoTime < 7 then
				print(Logo.."|cff00ff00SuperScan starting in: "..floor((WhoTime + 7 - GetTime())).."s|r")
				TimeLeft = floor((WhoTime + 7 - GetTime()))
			end
		end
	end
end

local function ToggleLockout(self)
	local name = self:GetName()
	
	if SuperGuildInviteOptions[name] == 3 then
		Frames["OptBtn4"]:SetTextColor(0.2,0.7,0.5)
		Frames["OptBtn4"]:SetText("Reinvite lockout: 24 hours")
		SuperGuildInviteOptions[name] = 1
	elseif SuperGuildInviteOptions[name] == 1 then
		Frames["OptBtn4"]:SetTextColor(0.5,1,1)
		Frames["OptBtn4"]:SetText("Reinvite lockout: 48 hours")
		SuperGuildInviteOptions[name] = 2
	else
		Frames["OptBtn4"]:SetText("Reinvite lockout: 72 hours")
		Frames["OptBtn4"]:SetTextColor(0.7,0.23,0.93)
		SuperGuildInviteOptions[name] = 3
	end
end	


local function Format_Whisper(whisper)
	local gName = GetGuildInfo(UnitName("Player"))
	local gLevel = GetGuildLevel()
	if strfind(whisper,"NAME") and strfind(whisper,"LEVEL") then
		local name = strsub(whisper,1,strfind(whisper,"NAME")-1)..gName..strsub(whisper,strfind(whisper,"NAME")+4)
		whisper = strsub(name,1,strfind(name,"LEVEL")-1)..gLevel..strsub(name,strfind(name,"LEVEL")+5)
	elseif strfind(whisper,"NAME") then
		whisper = strsub(whisper,1,strfind(whisper,"NAME")-1)..gName..strsub(whisper,strfind(whisper,"NAME")+4)
	elseif strfind(whisper,"LEVEL") then
		whisper = strsub(name,1,strfind(name,"LEVEL")-1)..gLevel..strsub(name,strfind(name,"LEVEL")+5)
	end
		
	SuperGuildInviteOptions.Whisper = whisper
	SendChatMessage(SuperGuildInviteOptions.Whisper,"WHISPER",nil,UnitName("Player"))
	return whisper
end

local function BlackList_Opt()
	if SuperGuildInviteOptions.BlackList then
		SuperGuildInviteOptions.BlackList = nil
		Frames["OptBtn7"]:SetTextColor(1,0,0)
		print(Logo.."|cffff0000Auto-Blacklisting turned OFF|r")
	else
		print(Logo.."|cff00ff00Auto-Blacklisting turned ON|r")
		SuperGuildInviteOptions.BlackList = true
		if not SuperGuildInviteOptions.tries then
			print(Logo.."|cff88ffffDefault Automatic BlackListing: 3 declines|r")
			print(Logo.."|cff88ffffTo change type: /sgi blacktime #|r")
			SuperGuildInviteOptions.tries = 3
		else
			print(Logo.."|cff88ffffCurrent Automatic Blacklisting: "..SuperGuildInviteOptions.tries.." declines|r")
			print(Logo.."|cff88ffffTo change type: /sgi blacktime #|r")
		end
		Frames["OptBtn7"]:SetTextColor(0,1,0)
	end
end
		

local function Create_EditBox(name,parent)																
	local frame = CreateFrame("EditBox",name,parent)
	frame:SetWidth(475)
	frame:SetHeight(220)
	frame:SetPoint("CENTER",UIParent)
	frame:SetFontObject("GameFontNormal")
	frame:SetTextInsets(20, 20, 55, -20)
	frame:SetMaxLetters(200)
	frame:SetMovable()
	frame:SetScript("OnMouseDown",function(self)
		self:StartMoving()
	end)
	frame:SetScript("OnMouseUp",function(self)
		self:StopMovingOrSizing()
	end)
	local backdrop = 
	{
		bgFile = "Interface/ACHIEVEMENTFRAME/UI-Achievement-Parchment-Horizontal", 
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
		tile = false,
		tileSize = 16,
		edgeSize = 16,
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
	}
	frame:SetBackdrop(backdrop)
	
	local font = frame:CreateFontString(nil,"OVERLAY","GameFontNormalLarge")
	font:SetText("Enter your Custom Whisper!\ntype (in caps) NAME and/or LEVEL for guildname and level\n(Max 200 letters)")
	font:SetPoint("CENTER",frame,"CENTER",0,30)
	frame:SetScript("OnEnterPressed", function(self)
		local search = self:GetText()
		local Whisp = Format_Whisper(search)
		self:Hide()
	end)
	frame:SetScript("OnHide",function(self)
		self:SetText("")
	end)
	local Box = CreateFrame("Frame",nil,frame)
	Box:SetWidth(455)
	Box:SetHeight(40)
	Box:SetPoint("CENTER",frame,"CENTER",0,-40)
	local backdrop2 = 
	{
		bgFile = nil, 
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
		tile = false,
		tileSize = 16,
		edgeSize = 16,
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
	}
	Box:SetBackdrop(backdrop2)
	
	
	Frames.btn = CreateButton(name.."Btn",frame)
	Anchor =
		{
			Point = "BOTTOM",
			RelativeFrame = frame,
			RelativePoint = "BOTTOM",
			xOfs = 0,
			yOfs = 10
		}
	Modify_Button(Frames.btn,"Okay",40,120,nil,Anchor,function(self)
		local search = self:GetParent():GetText()
		local Whisp = Format_Whisper(search)
		self:GetParent():Hide()
	end)
	local close = CreateFrame("Button",nil,frame,"UIPanelCloseButton")
	close:SetPoint("TOPRIGHT",frame,"TOPRIGHT",-4,-4)
	frame:Hide()

	return frame
end

local function Show_Search()
	if not SuperGuildInviteOptions.Search then 
		SuperGuildInviteOptions.Search = Create_EditBox("EditBox",UIParent)
		SuperGuildInviteOptions.Search:Show()
	else
		SuperGuildInviteOptions.Search:Show()
	end
end

local function Hide_Search()
	if SuperGuildInviteOptions.Search then SuperGuildInviteOptions.Search:Hide() end
end
	

local function Create_Options()
	local OptionsFrame = CreateFrame("Frame","SuperGuildInvite")
	OptionsFrame:SetHeight(365)
	OptionsFrame:SetWidth(500)
	SetSavedFramePos(OptionsFrame)
	
	OptionsFrame:SetMovable()
	OptionsFrame:RegisterForDrag("LeftButton","RightButton")
	OptionsFrame:SetScript("OnMouseDown",function(self)
		self:StartMoving()
	end)
	OptionsFrame:SetScript("OnMouseUp",function(self)
		self:StopMovingOrSizing()
		SaveCurFramePos(OptionsFrame)
	end)
	
	local backdrop = 
	{
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Background", 
		edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Border", 
		tile = true,
		tileSize = 16,
		edgeSize = 16,
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
	}
	OptionsFrame:SetBackdrop(backdrop)
	
	local TitleFont = OptionsFrame:CreateFontString(nil,"OVERLAY","GameFontNormalLarge")
	TitleFont:SetText("SuperGuildInvite "..version..version_min.." Options")
	TitleFont:SetPoint("TOP",OptionsFrame,"TOP",0,-20)
	
	local BottomFont = OptionsFrame:CreateFontString(nil,"OVERLAY","GameFontNormalLarge")
	BottomFont:SetText("Written by Janniie - Stormreaver EU")
	BottomFont:SetPoint("BOTTOM",OptionsFrame,"BOTTOM",0,20)
	OptionsFrame:Hide()
	SuperGuildInviteOptions.OptionsFrame = OptionsFrame
	
	-- Option button 1 --
	
	local OptBtn1 = CreateFrame("Button","OptBtn1",OptionsFrame)
	OptBtn1:SetHeight(40)
	OptBtn1:SetWidth(220)
	OptBtn1:SetPoint("TOP",OptionsFrame,"TOP",-120,-50)
	OptBtn1:SetBackdrop(backdrop)
	
	local OptFont1 = OptBtn1:CreateFontString(nil,"OVERLAY","GameFontNormal")
	OptFont1:SetText("Enable SuperGuildInvite")
	OptFont1:SetPoint("CENTER")
	if SuperGuildInviteOptions["OptBtn1"] then
		OptFont1:SetTextColor(0,1,0)
	else
		OptFont1:SetTextColor(1,0,0)
	end
	Frames["OptBtn1"] = OptFont1
	OptBtn1:SetScript("OnClick",OnOptionClick)
	
	
	-- Option button 2 --
	local OptBtn2 = CreateFrame("Button","OptBtn2",OptionsFrame)
	OptBtn2:SetHeight(40)
	OptBtn2:SetWidth(220)
	OptBtn2:SetPoint("TOP",OptionsFrame,"TOP",120,-50)
	OptBtn2:SetBackdrop(backdrop)
	
	local OptFont2 = OptBtn2:CreateFontString(nil,"OVERLAY","GameFontNormal")
	OptFont2:SetText("Send a whisper before inviting")
	OptFont2:SetPoint("CENTER")
	if SuperGuildInviteOptions["OptBtn2"] then
		OptFont2:SetTextColor(0,1,0)
	else
		OptFont2:SetTextColor(1,0,0)
	end
	Frames["OptBtn2"] = OptFont2
	OptBtn2:SetScript("OnClick",OnOptionClick)
	
	-- Option button 3 --
	local OptBtn3 = CreateFrame("Button","OptBtn3",OptionsFrame)
	OptBtn3:SetHeight(40)
	OptBtn3:SetWidth(220)
	OptBtn3:SetPoint("TOP",OptionsFrame,"TOP",-120,-105)
	OptBtn3:SetBackdrop(backdrop)
	
	local OptFont3 = OptBtn3:CreateFontString(nil,"OVERLAY","GameFontNormal")
	OptFont3:SetText("Auto-close after Who search")
	OptFont3:SetPoint("CENTER")
	if SuperGuildInviteOptions["OptBtn3"] then
		OptFont3:SetTextColor(0,1,0)
	else
		OptFont3:SetTextColor(1,0,0)
	end
	Frames["OptBtn3"] = OptFont3
	OptBtn3:SetScript("OnClick",OnOptionClick)
	
	-- Option button 4 --
	local OptBtn4 = CreateFrame("Button","OptBtn4",OptionsFrame)
	OptBtn4:SetHeight(40)
	OptBtn4:SetWidth(220)
	OptBtn4:SetPoint("TOP",OptionsFrame,"TOP",120,-105)
	OptBtn4:SetBackdrop(backdrop)
	
	local OptFont4 = OptBtn4:CreateFontString(nil,"OVERLAY","GameFontNormal")
	OptFont4:SetPoint("CENTER")
	if SuperGuildInviteOptions["OptBtn4"] == 1 then
		OptFont4:SetTextColor(0.2,0.7,0.5)
		OptFont4:SetText("Reinvite lockout: 24 hours")
	elseif SuperGuildInviteOptions["OptBtn4"] == 2 then
		OptFont4:SetTextColor(0.5,1,1)
		OptFont4:SetText("Reinvite lockout: 48 hours")
	else
		OptFont4:SetText("Reinvite lockout: 72 hours")
		OptFont4:SetTextColor(0.7,0.23,0.93)
	end
	Frames["OptBtn4"] = OptFont4
	OptBtn4:SetScript("OnClick",ToggleLockout)
	
	
	
	-- Option button 5 --
	local OptBtn5 = CreateFrame("Button","OptBtn5",OptionsFrame)
	OptBtn5:SetHeight(40)
	OptBtn5:SetWidth(220)
	OptBtn5:SetPoint("TOP",OptionsFrame,"TOP",-120,-160)
	OptBtn5:SetBackdrop(backdrop)
	
	local OptFont5 = OptBtn5:CreateFontString(nil,"OVERLAY","GameFontNormal")
	OptFont5:SetText("Manual Search")
	OptFont5:SetPoint("CENTER")
	if SuperGuildInviteOptions["OptBtn5"] then
		OptFont5:SetTextColor(0,1,0)
	else
		OptFont5:SetTextColor(1,0,0)
	end
	Frames["OptBtn5"] = OptFont5
	OptBtn5:SetScript("OnClick",OnOptionClick)
	
	-- Close button --
	
	local close = CreateFrame("Button",nil,OptionsFrame,"UIPanelCloseButton")
	close:SetPoint("TOPRIGHT",OptionsFrame,"TOPRIGHT",-4,-4)
	
	
	-- Option button 6 --
	local OptBtn6 = CreateFrame("Button","OptBtn6",OptionsFrame)
	OptBtn6:SetHeight(40)
	OptBtn6:SetWidth(220)
	OptBtn6:SetPoint("TOP",OptionsFrame,"TOP",120,-160)
	OptBtn6:SetBackdrop(backdrop)
	
	local OptFont6 = OptBtn6:CreateFontString(nil,"OVERLAY","GameFontNormal")
	OptFont6:SetText("Customize Whisper")
	OptFont6:SetPoint("CENTER")
	OptFont6:SetTextColor(1,1,0)
	
	OptBtn6:SetScript("OnClick",Show_Search)
	
	
	-- Options button 7 --
	local OptBtn7 = CreateFrame("Button","OptBtn7",OptionsFrame)
	OptBtn7:SetHeight(40)
	OptBtn7:SetWidth(220)
	OptBtn7:SetPoint("TOP",OptionsFrame,"TOP",-120,-215)
	OptBtn7:SetBackdrop(backdrop)
	
	local OptFont7 = OptBtn7:CreateFontString(nil,"OVERLAY","GameFontNormal")
	OptFont7:SetText("Auto Blacklist")
	OptFont7:SetPoint("CENTER")
	if SuperGuildInviteOptions.BlackList then
		OptFont7:SetTextColor(0,1,0)
	else
		OptFont7:SetTextColor(1,0,0)
	end
	
	Frames["OptBtn7"] = OptFont7
	OptBtn7:SetScript("OnClick",BlackList_Opt)
	
	-- Options button 8 --
	local OptBtn8 = CreateFrame("Button","OptBtn8",OptionsFrame)
	OptBtn8:SetHeight(40)
	OptBtn8:SetWidth(220)
	OptBtn8:SetPoint("TOP",OptionsFrame,"TOP",120,-215)
	OptBtn8:SetBackdrop(backdrop)
	
	local OptFont8 = OptBtn8:CreateFontString(nil,"OVERLAY","GameFontNormal")
	OptFont8:SetText("Whisper Auto Invite")
	OptFont8:SetPoint("CENTER")
	if SuperGuildInviteOptions.BlackList then
		OptFont8:SetTextColor(0,1,0)
	else
		OptFont8:SetTextColor(1,0,0)
	end
	
	Frames["OptBtn8"] = OptFont8
	OptBtn8:SetScript("OnClick",OnOptionClick)
	
	-- Options Button 9 --
	local OptBtn9 = CreateFrame("Button","OptBtn9",OptionsFrame)
	OptBtn9:SetHeight(40)
	OptBtn9:SetWidth(220)
	OptBtn9:SetPoint("TOP",OptionsFrame,"TOP",0,-270)
	OptBtn9:SetBackdrop(backdrop)
	
	local OptFont9 = OptBtn9:CreateFontString(nil,"OVERLAY","GameFontNormal")
	OptFont9:SetText("SuperScan")
	OptFont9:SetPoint("CENTER")
	if SuperGuildInviteOptions["OptBtn9"] then
		OptFont9:SetTextColor(0,1,0)
	else
		OptFont9:SetTextColor(1,0,0)
	end
	
	Frames["OptBtn9"] = OptFont9
	OptBtn9:SetScript("OnClick",OnOptionClick)
	
end


local function Show_Options()
	if not SuperGuildInviteOptions.OptionsFrame then 
		Create_Options() 
		SuperGuildInviteOptions.OptionsFrame:Show()
	else
		SuperGuildInviteOptions.OptionsFrame:Show()
	end
end

local function Hide_Options()
	if SuperGuildInviteOptions.OptionsFrame then SuperGuildInviteOptions.OptionsFrame:Hide() end
end
	
	
	

	
	


local function ShowTimer()
	if not Frames["Timer"] then
		CreateTimerWorld()
		Frames["Timer"]:Show()
	else
		Frames["Timer"]:Show()
	end
end

local function HideTimer()
	if Frames["Timer"] then Frames["Timer"]:Hide() end
end
		
	
	
local function SlashCommandHndl(msg)
	if msg == 'toggle' then
		if SuperGuildInviteOptions["OptBtn1"] then
			SuperGuildInviteOptions["OptBtn1"] = false
			ChatFrame1:AddMessage(Logo.."SuperGuildInvite is now OFF",1,0,0,1)
		else
			SuperGuildInviteOptions["OptBtn1"] = true
			ChatFrame1:AddMessage(Logo.."SuperGuildInvite is now ON",0,1,0,1)
		end
	elseif msg == 'config' then
		Show_Options()
	elseif msg == 'hide' then
		Hide_Options()
	elseif msg == 'on' then
		SuperGuildInviteOptions["OptBtn1"] = true
		ChatFrame1:AddMessage(Logo.."SuperGuildInvite is now ON",0,1,0,1)
	elseif msg == 'off' then
		SuperGuildInviteOptions["OptBtn1"] = false
		ChatFrame1:AddMessage(Logo.."SuperGuildInvite is now OFF",1,0,0,1)
	elseif msg == 'timer' then
		ShowTimer()
	elseif msg == 'timeroff' then
		HideTimer()
	elseif msg == 'reset' then
		SuperGuildInviteOptions = nil
		SuperGuildInviteGeneral = nil
		BlackList = nil
		LoginPlayer()
		ChatFrame1:AddMessage(Logo.."SuperGuildInvite has reset all previous encounters and settings.",1,0.2,0.2,1)
	elseif strfind(msg,"blacklist") then
		local name = strsub(msg,11)
		Add_To_Blacklist(name,"MANUAL")
	elseif strfind(msg,"blacktime") then
		local tries = tonumber(strsub(msg,11))
		SuperGuildInviteOptions.tries = tries
		print(Logo.."|cff88ffffAutomatic Blacklisting changed to: "..SuperGuildInviteOptions.tries.."|r")
	elseif msg == '' or msg == 'help' then
		print(Logo.."|cff88ffffVersion "..version)
		print(Logo.."|cff88ffffSlashCommands:")
		print(Logo.."|cff88ffff/sgi toggle, turn on/off")
		print(Logo.."|cff88ffff/sgi on, turn on")
		print(Logo.."|cff88ffff/sgi off, turn off")
		print(Logo.."|cff88ffff/sgi config, open options")
		print(Logo.."|cff88ffff/sgi blacklist name, blacklist the person from being invited")
		print(Logo.."|cff88ffff/sgi blacktime #, the amount of declines before auto-blacklist")
		print(Logo.."|cff88ffff/sgi reset, hard reset of all settings, encounters and blacklistings")
	end
end



Funcs.OnRegisteredEvent = OnRegisteredEvent
Funcs.SlashCommandHndl = SlashCommandHndl

